#include "Parsodus/lrtables/LR1Item.h"

namespace pds {
namespace lr {

bool LR1Item::operator<(const LR1Item& rhs) const {
    if (dotIdx != rhs.dotIdx) {
        return dotIdx < rhs.dotIdx;
    } else if (rule != rhs.rule) {
        return rule < rhs.rule;
    } else {
        return lookaheads < rhs.lookaheads;
    }
}

bool LR1Item::operator==(const LR1Item& rhs) const {
    return dotIdx == rhs.dotIdx && rule == rhs.rule && lookaheads == rhs.lookaheads;
}
        
} /* lr */ 
} /* pds  */ 
