#pragma once
#ifndef UTIL_FOLLOWSET_H_WIGGZMRF
#define UTIL_FOLLOWSET_H_WIGGZMRF

#include "Parsodus/util/firstset.h"

#include <map>
#include <set>
#include <string>
#include <vector>

namespace pds {
namespace util {

class FollowSet {
    public:
        FollowSet(const Grammar& g, const FirstSet& first); 

        /**
         * Get the follow set for the given variable
         */
        std::set<std::string> operator()(std::string key) const;

    private:
        std::map<std::string, std::set<std::string>> m_follow;
};

} /* util */
} /* pds */

#endif /* UTIL_FOLLOWSET_H_WIGGZMRF */
